<template>
  <el-main>
    <el-form ref="form" :model="form" label-width="80px">
      <el-row>
        <el-col :span="12">
          <el-form-item label="文号">
            <el-input type="text"
                      v-model="form.unitName"
                      placeholder="请输入_______移交〔     〕第    号">
            </el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="部门名称">
            <el-input type="text"
                      v-model="form.unitName"
                      placeholder="请输入部门名称">
            </el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="当事人姓名">
            <el-input type="text"
                      v-model="form.unitName"
                      placeholder="请输入当事人姓名">
            </el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="违法日期">
            <el-date-picker
              v-model="form.unitName"
              type="date"
              :value-format="'yyyy-MM-dd'"
              placeholder="选择违法日期">
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="违法地点">
        <el-input type="text"
                  v-model="form.unitName"
                  placeholder="请输入违法地点">
        </el-input>
      </el-form-item>
      <el-form-item label="违法行为">
        <el-input type="text"
                  v-model="form.unitName"
                  placeholder="请输入违法行为">
        </el-input>
      </el-form-item>
      <el-form-item label="法律依据">
        <el-input type="text"
                  v-model="form.unitName"
                  placeholder="请输入违反法律依据名称">
        </el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="送达日期">
            <el-date-picker
              v-model="form.unitName"
              type="date"
              :value-format="'yyyy-MM-dd'"
              placeholder="选择送达日期">
            </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="决定书文号">
            <el-input type="text"
                      v-model="form.unitName"
                      placeholder="请输入决定书文号">
            </el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item label="联系人">
            <el-input type="text"
                      v-model="form.unitName"
                      placeholder="请输入联系人姓名">
            </el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="联系电话">
            <el-input type="text"
                      v-model="form.unitName"
                      placeholder="请输入联系电话">
            </el-input>
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item label="单位地址">
        <el-input type="text"
                  v-model="form.unitName"
                  placeholder="请输入单位地址">
        </el-input>
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item label="结案日期">
            <el-date-picker
              v-model="form.unitName"
              type="date"
              :value-format="'yyyy-MM-dd'"
              placeholder="选择结案日期">
            </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="扣章日期">
            <el-date-picker
              v-model="form.unitName"
              type="date"
              :value-format="'yyyy-MM-dd'"
              placeholder="选择扣章日期">
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>
      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>

    <div style="text-align: center">
      <el-button v-if="isFinish!='2'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-if="isFinish!='2'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
    </div>
  </el-main>
</template>

<script>
import WordView from "@/views/News/word-view";
import {getObj, saveObj} from "@/api/News/illegalProperty";
import moment from "moment";

export default {
  name: "illegalProperty",
  props: ['isShowYulan','id','isFinish','processId','title'],
  components:{
    WordView
  },
  data() {
    return {
      showView:false,
      form: {
        registerState:'',
        unitName: '',//单位简称
        askdPersion: '',//当事人姓名或单位
        breakLowTime: '',//违规时间
        breakLowContent: '',//违规行为
        lows: '',//违反法律条例
        tiao:'',
        askdTime: '',//通知时间
        askdAdress: '',//承办机构
        takeEvidenceOthers: '',//其他内容
        takeEvidences: [],
        linkMan: '',//联系人
        linkPhone: '',//联系电话
        issuingDate: '',//扣章日期
      },
      formLabelWidth: "140px"
    }
  },
  created() {
    this.init()
  },
  methods: {
    init() {
      getObj(this.id).then((res) => {
        if (res.data.code == 0) {
          // 转换null为""
          // let v = res.data.data;
          // for (let attr in v) {
          //   if (v[attr] == null) {
          //     v[attr] = "";
          //   }
          // }
          // let str = JSON.stringify(v);
          // let data = JSON.parse(str);
          this.form = res.data.data;
        }
      });
    },

    dataFormSubmit(type) {
      console.log(type)
      this.$refs['form'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                if (res.data.code == 0) {
                  obj.$message.success('操作成功');
                  obj.cancel();
                  obj.$emit('getDataList');
                }
              })
            })
          } else {
            obj.form.registerState = type;
            obj.form.registerId = obj.id;
            obj.form.processId = obj.processId;
            saveObj(obj.form).then((res) => {
              // this.submitLoading = false;
              if (res.data.code == 0) {
                obj.$message.success("操作成功");
                obj.cancel();
                obj.$emit('getDataList');
              }
            })
          }
        }
      })
    },
    cancel() {
      this.$emit('cancel', false);
    },
    cancelWord() {
      this.showView = false;
    },
    viewVord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/dcxwtzs.docx");
      })
    },
    downloadWord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      let wordData = this.transforData(data);
      WordView.methods.exportDoc(wordData, "/wordes/dcxwtzs.docx", title+".docx");
    },
    transforData(obj) {
      let s = JSON.stringify(obj);
      let data = JSON.parse(s);

      let str = data.takeEvidences;
      if (str.indexOf("0") >= 0){
        data.zi = true;
        data.ran = false;
      }else {
        data.zi = false;
        data.ran = true;
      }
      if (str.indexOf("1") >= 0){
        data.ge = true;
        data.ti = false;
      }else {
        data.ge = false;
        data.ti = true;
      }
      if (str.indexOf("2") >= 0){
        data.qi = true;
        data.ta = false;
      }else {
        data.qi = false;
        data.ta = true;
      }
      if (data.breakLowTime != '' && data.breakLowTime != null) {
        data.breakLowTime = moment(data.breakLowTime).format('YYYY年MM月DD日');
      }else {
        data.breakLowTime = '  年  月  日'
      }
      if (data.askdTime != '' && data.askdTime != null) {
        data.askdTime = moment(data.askdTime).format('YYYY年MM月DD日HH时mm分');
      }else {
        data.breakLowTime = '  年  月  日  时  分'
      }
      if (data.issuingDate != '' && data.issuingDate != null) {
        data.issuingDate = moment(data.issuingDate).format('YYYY年MM月DD日');
      }else {
        data.issuingDate = '  年  月  日'
      }

      return data;
    }
  }
}
</script>

<style scoped>

</style>
